#include <png.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>

#define ERROR 1

void user_write_data(png_structp png_ptr,
                png_bytep data, png_size_t length)
{
#ifdef NDS
FAT_FILE *fp = (FAT_FILE *) png_get_io_ptr(png_ptr);
FAT_fwrite(data, 1, length, fp);

#else
FILE *fp = (FILE *) png_get_io_ptr(png_ptr);
fwrite(data, 1, length, fp);
#endif

}

void user_flush_data(png_structp png_ptr)
{
#ifdef NDS
    // no fflush on fat lib?
#else
FILE *fp = (FILE *) png_get_io_ptr(png_ptr);
fflush(fp);


#endif
}
int dopng(char *filein, int p1, int p2, int p3, int p4);


int main(int argc, char *argv[])
{
    int p1=0,p2=1,p3=2,p4=0;
    FILE *fin, *fout;
   
    if(argc < 2)
        fin = fopen("img.bin", "rb");
    else
        fin = fopen(argv[1], "rb");

    if(argc < 3)
    {
        if(argc == 2)
        {
            char buf[256];
            sprintf(buf, "%s", argv[1]);
            int n = strlen(buf);
            buf[n-3] = 'p';
            buf[n-2] = 'n';
            buf[n-1] = 'g';
            fout = fopen(buf, "wb");
        }
        else
            fout = fopen("img.png", "wb");
    }
    else
        fout = fopen(argv[2], "wb");
        
       
    if(!fin || !fout)
    {
        perror("erorr opening files for read/write");
        exit(1);
    }

    if(argc >= 2)
    {
        int strl = strlen(argv[1]);
        if(tolower(argv[1][strl-3]) == 'r'
         &&tolower(argv[1][strl-2]) == 'l'
         &&tolower(argv[1][strl-1]) == 'e')
        {

            FILE *fde = fopen("tmp.bin", "wb");
            if(!fde)
            {
                perror("error opening temp file for outp");
                exit(1);
            }

            unsigned short ctr = 0;
            unsigned short byte = 0;
            unsigned short in = 0;
            while(!feof(fin))
            {
                fread(&in, 1, 2, fin);
                if(in == 0xfffe)
                {
                    fread(&ctr, 1, 2, fin);
                    fread(&byte, 1, 2, fin);
                    for(int n=0; n<ctr; n++)
                    {
                        fwrite(&byte, 1, 2, fde);
                    }
                }
                else
                    fwrite(&in, 1, 2, fde);
            }
            fclose(fin);
            fclose(fde);
                
            fin = fopen("tmp.bin", "rb");
            if(!fin)
            {
                perror("error opening temp file for inpt");
                exit(1);
            }
        }
    }



    
       png_structp png_ptr = png_create_write_struct
          (PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
       if (!png_ptr)
          return (ERROR);

       png_infop info_ptr = png_create_info_struct(png_ptr);
       if (!info_ptr)
       {
          png_destroy_write_struct(&png_ptr,
            (png_infopp)NULL);
          return (ERROR);
       }

           if (setjmp(png_jmpbuf(png_ptr)))
           {
              png_destroy_write_struct(&png_ptr, &info_ptr);
              fclose(fin);
              return (ERROR);
           }

//           png_init_io(png_ptr, fout);
           png_set_write_fn(png_ptr,
                       (voidp)fout, user_write_data,
                       user_flush_data);

           png_set_IHDR(png_ptr, info_ptr, 512, 384,
              8, PNG_COLOR_TYPE_RGB, PNG_INTERLACE_NONE,
              PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);


//           png_color pal[256];
  //         pal[0] = 

           png_byte *rows[384];
           int n = 0;
           for(int i=0; i<384; i++)
           {
               unsigned char buf[1024];
               rows[i] = (png_byte *)malloc(512*3);
               int nn = fread(buf, 1, 1024, fin);
               n += nn;
               for(int x=0;x<512;x++)
               {
                   unsigned int c = buf[x*2 +p4 ] | (buf[x*2 + (1-p4) ] << 8);
                   c = c & ~(1<<15);
                   rows[i][x*3+p1] = (((c    ) & 31) <<3)&255;
                   rows[i][x*3+p2] = (((c>> 5) & 31) <<3)&255;
                   rows[i][x*3+p3] = (((c>>10) & 31) <<3)&255;
               }
           }
           printf("read %d bytes.\n", n);
            
           png_set_rows(png_ptr, info_ptr, rows);

           png_write_png(png_ptr, info_ptr, 0, NULL);
            printf("wrote png file.\n");

           return 0;
}

